

/*
  ---------------------------------------------------------------|
                              Optilogic                          |
                              Rover Basic                        |
                              V0.1                               |
                                                                 |
  ---------------------------------------------------------------|

*/


//IO
//HC-SR04                     Arduino
//Trig pin:                   7
//Echo pin:                   8

//Motor controller            Arduino
//pin1                        5
//pin2                        6
//pin3                        9
//Pin4                        10

#define trigPin 7
#define echoPin 8

#define pin1 5
#define pin2 6
#define pin3 9
#define pin4 10

void setup() {
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(pin1, OUTPUT);
  pinMode(pin2, OUTPUT);
  pinMode(pin3, OUTPUT);
  pinMode(pin4, OUTPUT);

  //Serial.begin(9600);

  //Delay motorstart 5s
  delay(5000);
}

void loop() {
  //Measure the distance
  int dist = GetDistance();

  //If the distance is less than 20cm, turn
  if (dist < 20) Turn();
  //If the distance is more than 20cm, drive forward
  else Forward();

  //Sleep 100ms before next loop
  delay(100);



}

void Forward() {
  //Function for driving forward
  digitalWrite(pin1, HIGH);
  digitalWrite(pin2, LOW);
  digitalWrite(pin3, HIGH);
  digitalWrite(pin4, LOW);

}

void Turn() {
  //Wait 500ms
  Hold(500);

  //Function for turning
  digitalWrite(pin1, LOW);
  digitalWrite(pin2, HIGH);
  digitalWrite(pin3, HIGH);
  digitalWrite(pin4, LOW);
  delay(500);

  //Wait 500ms
  Hold(500);
}

void Hold(int wait) {
  //Function for stopping the motors, and waiting
  digitalWrite(pin1, LOW);
  digitalWrite(pin2, LOW);
  digitalWrite(pin3, LOW);
  digitalWrite(pin4, LOW);
  delay(wait);
}

int GetDistance() {
  //Function for getting the distance

  //set trigger pin low for 5 µs
  digitalWrite(trigPin, LOW);
  delayMicroseconds(5);

  //Set trigger pin high for 10 µs
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  //time the echopin until it goes high
  long duration = pulseIn(echoPin, HIGH);

  //Calculate the distance
  //((Duration * speed of sound) / 2 distances)
  return ((duration * 0.034) / 2);

}
